Imports System.Data
Imports System.Data.OleDb
Imports System.Web.Mail
Imports System.IO

Imports SendMail
Imports General

Partial Class CreateAdmin
    Inherits System.Web.UI.Page

    Dim objCon As New OleDbConnection
    Dim objPwdCon As New OleDbConnection
    Dim objMail As OleDbConnection
    Dim adp As New OleDbDataAdapter

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            If Session("CoCode") = String.Empty Then
                Response.Redirect("Login.aspx")
            ElseIf StrComp(Session("EmpId"), "Admin") <> 0 Then
                Response.Redirect("EmpLogin.aspx")
            End If
            objCon = New OleDb.OleDbConnection(Session("myConnection"))
            objCon.Open()
            objPwdCon = New OleDb.OleDbConnection(Session("PwdConnection"))
            objPwdCon.Open()
            If Not Page.IsPostBack Then
                BindDT()
            End If
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub btnProceed_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnProceed.Click
        Try
            Dim EmpMailID As String
            Dim strEmpName As String
            Dim strEmpID As String
            Dim strPassword As String
            Dim objReader As OleDbDataReader

            If txtEmpCode.Text = "" Then
                txtName.Text = ""
                lblMsg.Text = "Please Enter Employee Code"
                Exit Sub
            ElseIf InStr(txtEmpCode.Text, "'", CompareMethod.Binary) > 0 Then
                txtName.Text = ""
                lblMsg.Text = "The Employee Code does not exists"
                Exit Sub
            End If

            If GetAreaAdmin(Session("PwdConnection"), txtEmpCode.Text) = True Then
                lblMsg.Text = "This Employee already selected as AreaAdmin"
                Exit Sub
            End If

            Dim oleDBcmd As New OleDbCommand("Select EmpCode,EmpName,[Password] from EmpMaster where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'", objCon)
            Dim Dr As OleDbDataReader

            Dr = oleDBcmd.ExecuteReader

            If Dr.HasRows = False Then
                txtName.Text = String.Empty
                lblMsg.Text = "Employee not present in Database"
                Exit Sub
            Else
                lblMsg.Text = ""
                Dr.Read()
                strPassword = Dr("Password")
                strEmpID = Dr("EmpCode")
                strEmpName = Dr("EmpName")
            End If
            Dr.Close()

            Dim oleDBcmdPwd As New OleDbCommand("Select Count(EmpCode) from Employee where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'", objPwdCon)

            If oleDBcmdPwd.ExecuteScalar = 0 Then
                oleDBcmdPwd.CommandText = "Insert into Employee (EmpCode,PWD,AreaAdmin) values ('" & strEmpID & "','" & strPassword & "',true)"
                oleDBcmdPwd.ExecuteNonQuery()
            Else
                oleDBcmdPwd.CommandText = "Update Employee set AreaAdmin = true where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'"
                oleDBcmdPwd.ExecuteNonQuery()
            End If

            Call CreateAAdmFolders()

            EmpMailID = GetEmail(Session("myconnection"), txtEmpCode.Text)

            Dim sb As New StringBuilder
            sb = sb.Append("Company Code: " & Session("CoCode") & "<br />" & _
                            "Employee Name: " & strEmpName & "<br />" & _
                            "Employee ID: " & strEmpID & "<br /><br />" & _
                            "This is to inform you that you have been selected for the post of Area Admin by the administrator." & _
                            "<br /><br />" & "Kindly Contact the administrator for further details.")

            '--Connecting to the Emails.mdb
            objMail = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;data source=" & Server.MapPath(".") & "\Emails.mdb;jet OLEDB:Database Password=Ffcs")
            objMail.Open()

            adp = New OleDbDataAdapter("select * from Emails where CompanyCode='" & Session("CoCode") & Mid(Session("Period"), 3, 2) & "'", objMail)
            objReader = adp.SelectCommand.ExecuteReader()

            If objReader.HasRows Then objReader.Read()
            If objReader.HasRows Then
                Call Mailer(objReader("AdminEmail"), objReader("AdminEmail"), "Notification of Area Admin", sb.ToString, "localhost", , EmpMailID)
                'abhay start
                'Ver 3.5-REQ280 Start
                ' Call funSendMail()
                'Ver 3.5-REQ280 end 
                If funSendMail() Then
                    BindDT()
                    If EmpMailID = String.Empty Then
                        lblMsg.Text = "Mail Sent Successfully to Admin Only,Email Id is not available for this Employee"
                    Else
                        lblMsg.Text = "Mail Sent Successfully to Admin," & strEmpName
                    End If
                Else
                    lblMsg.Text = "Error while sending mail,please check your SMTP details."
                End If
            Else
                lblMsg.Text = "Admin Email Id Not Found!"

                Exit Sub
            End If
            objMail.Close()
            objMail = Nothing
            txtEmpCode.Text = ""
            txtName.Text = ""

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try

        BindDT()
    End Sub

    Private Sub CreateAAdmFolders()
        Dim strPath1 As String, strPath2 As String
        Dim NewContent As String

        NewContent = "" 'Default Value
        strPath1 = System.Configuration.ConfigurationManager.AppSettings("FilePath") & "/" & UCase(Replace(txtEmpCode.Text, "'", "")) & "/" & "Upload"
        strPath2 = System.Configuration.ConfigurationManager.AppSettings("FilePath") & "/" & UCase(Replace(txtEmpCode.Text, "'", "")) & "/" & "Download"

        Try
            Directory.CreateDirectory(strPath1)
            Directory.CreateDirectory(strPath2)
            For intI As Integer = 4 To 12
                Directory.CreateDirectory(strPath2 & "\" & MonthName(intI, True) & "-" & Mid(Session("Period"), 1, 4))
            Next
            For intI As Integer = 1 To 3
                Directory.CreateDirectory(strPath2 & "\" & MonthName(intI, True) & "-" & Mid(Session("Period"), 6, 4))
            Next
        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try
    End Sub

    Protected Sub txtEmpCode_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtEmpCode.TextChanged
        Try
            If txtEmpCode.Text = "" Then Exit Sub
            If InStr(txtEmpCode.Text, "'", CompareMethod.Binary) > 0 Then
                lblMsg.Text = "The Employee Code does not exists"
                Exit Sub
            End If
            Dim oleDBcmd As New OleDbCommand("Select EmpName from EmpMaster where EmpCode ='" & Replace(txtEmpCode.Text, "'", "") & "'", objCon)
            Dim Dr As OleDbDataReader

            Dr = oleDBcmd.ExecuteReader
            If Dr.HasRows = False Then
                txtName.Text = String.Empty
                lblMsg.Text = "Employee not present in Database"
                Exit Sub
            Else
                Dr.Read()
                lblMsg.Text = ""
                txtName.Text = Dr("EmpName")
            End If

        Catch ex As Exception
            lblMsg.Text = ex.Message.ToString
        End Try

    End Sub

    Private Sub BindDT()
        Dim dt As New DataTable()
        Dim da As New OleDbDataAdapter("select e.empcode,empname, areaadmin from employee e, `" & Session("strPath").ToString() & "\PayPac.mdb;pwd=Ffcs`.empmaster m where e.empcode=m.empcode and e.areaadmin=true", Session("PwdConnection").ToString())
        da.Fill(dt)
        Threading.Thread.Sleep(500)
        gvAreaAdmin.DataSource = dt
        gvAreaAdmin.DataBind()

    End Sub

    Protected Sub Page_Unload(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Unload
        objCon.Close()
        objPwdCon.Close()
    End Sub

    Protected Sub gvAreaAdmin_RowEditing(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewEditEventArgs) Handles gvAreaAdmin.RowEditing
        Dim con As New OleDbConnection(Session("PwdConnection"))
        Dim cmd As New OleDbCommand("update employee set areaadmin=false where EmpCode='" & CType(gvAreaAdmin.Rows(e.NewEditIndex).FindControl("lblempcode"), Label).Text.Trim() & "'", con)
        con.Open()
        cmd.ExecuteNonQuery()
        con.Close()
        BindDT()
        lblMsg.Text = "Employee remove successfully."
    End Sub
End Class
