﻿Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing

Partial Class DocumentMaster
    Inherits System.Web.UI.Page
    Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUpload.Click
        If FileUpload1.PostedFile.FileName.Trim() = "" Then
            Alert.Show("Please select the file.")
            Exit Sub
        End If
        Dim strpath As String = "" & Session("strPath") & "\Document\" & IO.Path.GetFileName(FileUpload1.PostedFile.FileName)

        If IO.File.Exists(strpath) Then
            Alert.Show("File allready exist.")
            Exit Sub
        End If
        If IsRecordExist() Then
            Alert.Show("File allready exist.")
            Exit Sub
        End If
        Dim NextID As String = ""
        Try
            NextID = General.GetData(Session("pwdConnection"), "select max(docid) from DocumentMaster")
        Catch ex As Exception
            If ex.Message.Contains("cannot find the input table") Then
                Alert.Show("Please update database.")
                btnAdd.Enabled = False
                btnUpload.Enabled = False
                Exit Sub
            End If
        End Try

        FileUpload1.PostedFile.SaveAs(strpath)

        If NextID = "" Then
            NextID = "D0001"
        Else
            NextID = "D" & (Convert.ToInt32(NextID.Substring(1)) + 1).ToString().PadLeft(4, "0")
        End If
        General.ExecuteDML(Session("pwdConnection"), "insert into DocumentMaster(DocID,DocName,DocPath,IsActive) values ('" & NextID & "','" & FileUpload1.PostedFile.FileName & "','" & strpath & "',true)")
        BindGrid()
    End Sub
        Sub BindGrid()
        Dim da As New OleDbDataAdapter("select * from DocumentMaster", Session("pwdConnection").ToString())
        Dim ds As New DataSet()
        da.Fill(ds)
        gvDetails.DataSource = ds
        gvDetails.DataBind()
    End Sub
    Sub BindGridRole()
        Dim da As New OleDbDataAdapter("select r.RoleId,r.RoleName from DocumentRole d,RoleMaster r where d.ROleid=r.roleID and docid='" & ltrDocID.Text & "'", Session("pwdConnection").ToString())
        Dim ds As New DataSet()
        da.Fill(ds)
        gvRole.DataSource = ds
        gvRole.DataBind()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            Try
                If Session("EmpId") = String.Empty Then
                    Response.Redirect("login.aspx")
                End If
                tblRole.Visible = False
                If Not IO.Directory.Exists(Session("strPath") & "/Document") Then
                    IO.Directory.CreateDirectory(Session("strPath") & "/Document")
                End If
            Catch ex As Exception
                Alert.Show("Please create Document folder in company folder,and give full permission to this folder.")
                btnUpload.Enabled = False
            End Try

            Try
                BindGrid()
            Catch ex As Exception
                If ex.Message.Contains("cannot find the input table") Then
                    Alert.Show("Please update database.")
                    btnAdd.Enabled = False
                    btnUpload.Enabled = False
                    Exit Sub
                End If
            End Try
            Try


                ddlRole.DataSource = General.GetDataTable(Session("pwdConnection").ToString(), "select * from RoleMaster where IsActive=true")
                ddlRole.DataTextField = "RoleName"
                ddlRole.DataValueField = "RoleID"
                ddlRole.DataBind()
                tblRole.Visible = False
            Catch ex As Exception
                Alert.Show("Please update Roles.")
            End Try
        End If

    End Sub


    Protected Sub gvDetails_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles gvDetails.RowCommand
        Dim RowIndex As Integer = DirectCast(DirectCast(e.CommandSource, LinkButton).NamingContainer, GridViewRow).RowIndex
        Dim docid As String = gvDetails.Rows(RowIndex).Cells(1).Text
        Dim strpath As String = Session("strPath") & "/Document/"
        If e.CommandName = "Active" Then
            Dim active As Boolean = IIf(CType(gvDetails.Rows(RowIndex).FindControl("lnkUpdate"), LinkButton).Text = "Deactive", True, False)
            Dim con As New OleDbConnection(Session("pwdConnection").ToString())
            con.Open()
            Dim cmd As New OleDbCommand("update  DocumentMaster set IsActive=" & active.ToString() & " where DocID='" & docid & "'", con)
            cmd.ExecuteNonQuery()
            con.Close()
        ElseIf e.CommandName = "DeleteDoc" Then
            System.IO.File.Delete(strpath & gvDetails.Rows(RowIndex).Cells(2).Text)
            General.ExecuteDML(Session("pwdConnection").ToString(), "delete from DocumentRole where DocID='" & docid & "'")
            Dim con As New OleDbConnection(Session("pwdConnection").ToString())
            con.Open()
            Dim cmd As New OleDbCommand("delete from  DocumentMaster where DocID='" & docid & "'", con)
            cmd.ExecuteNonQuery()
            con.Close()
        ElseIf e.CommandName = "UpdatePermission" Then
            General.ExecuteDML(Session("pwdConnection").ToString(), "Update DocumentMaster set IsRestricted=" & CType(gvDetails.Rows(RowIndex).FindControl("rdrestricted"), RadioButton).Checked & " where DocID='" & docid & "'")
        End If
        BindGrid()
    End Sub

    Protected Sub btnAdd_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        If ddlRole.Text.Trim() = "" Then
            Alert.Show("Please select the role.")
            Exit Sub
        End If
        If Not IsDocRoleExist() Then
            General.ExecuteDML(Session("pwdConnection").ToString(), "insert into DocumentRole values('" & ltrDocID.Text & "','" & ddlRole.SelectedValue & "')")
        Else
            Alert.Show("Role allready exists")
        End If
        tblRole.Visible = False
        gvDetails.Enabled = True
        gvDetails.SelectedIndex = -1
    End Sub
    Protected Function IsRecordExist() As Boolean
        Dim b As Boolean
        Dim con As OleDbConnection = New OleDbConnection(Session("pwdConnection").ToString())
        Dim cmd As OleDbCommand = New OleDbCommand("select * from DocumentMaster where Docname='" + FileUpload1.PostedFile.FileName + "'", con)
        con.Open()
        Dim rd As OleDbDataReader = cmd.ExecuteReader()
        b = rd.HasRows
        con.Close()
        Return b
    End Function
    Protected Function IsDocRoleExist() As Boolean
        Dim b As Boolean
        Dim con As OleDbConnection = New OleDbConnection(Session("pwdConnection").ToString())
        Dim cmd As OleDbCommand = New OleDbCommand("select * from DocumentRole where DocID='" & ltrDocID.Text & "' and RoleID='" & ddlRole.SelectedValue & "'", con)
        con.Open()
        Dim rd As OleDbDataReader = cmd.ExecuteReader()
        b = rd.HasRows
        con.Close()
        Return b
    End Function
    Protected Sub gvDetails_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles gvDetails.SelectedIndexChanged

        ltrDocID.Text = gvDetails.SelectedRow.Cells(1).Text
        gvDetails.Enabled = False
        tblRole.Visible = True
        BindGridRole()
    End Sub

    Protected Sub btnCancle_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancle.Click
        tblRole.Visible = False
        gvDetails.Enabled = True
        gvDetails.SelectedIndex = -1
    End Sub

    Protected Sub gvRole_RowCommand(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewCommandEventArgs) Handles gvRole.RowCommand
        Dim RowIndex As Integer = DirectCast(DirectCast(e.CommandSource, LinkButton).NamingContainer, GridViewRow).RowIndex

        If e.CommandName = "Remove" Then
            General.ExecuteDML(Session("pwdConnection").ToString(), "Delete from DocumentRole Where DocID=" & ltrDocID.Text & " and RoleID='" & gvRole.Rows(RowIndex).Cells(0).Text & "'")
            BindGridRole()
        End If
    End Sub
    Public Function IsRecordExists() As Boolean
        Dim b As Boolean
        Return b
    End Function
End Class
