Imports System.IO

Partial Class DownloadFile
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Session("EmpId") = String.Empty Then
            Response.Redirect("EmpLogin.aspx")
        End If
        Try
            If Request.QueryString("File") = String.Empty Then
                lblMessage.Text = "Please Specify the File to download"
                Exit Sub
            End If
            Call DisplayDownloadDialog(Request.QueryString("File"))
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub

    Private Sub DisplayDownloadDialog(ByVal PathVirtual As String)
        Try
            Dim testPath As String
            Dim fnChars As Char()

            testPath = PathVirtual

            'Response.Write("Directory Name: " + Path.GetDirectoryName(testPath))
            'If (Path.HasExtension(testPath)) Then
            '    Response.Write("File extension: " + Path.GetExtension(testPath))
            'End If
            'Response.Write("Filename: " + Path.GetFileName(testPath))
            'Response.Write("Filename w/o ext: " + Path.GetFileNameWithoutExtension(testPath))
            'Response.Write("Full path: " + Path.GetFullPath(testPath))
            'fnChars = Path.GetInvalidFileNameChars()
            'If (Path.IsPathRooted(testPath)) Then
            '    Response.Write("Root: " + Path.GetPathRoot(testPath))
            'End If

            Dim strPhysicalPath As String
            Dim objFileInfo As System.IO.FileInfo
            strPhysicalPath = Path.GetFullPath(testPath)
            'exit if file does not exist
            If Not System.IO.File.Exists(strPhysicalPath) _
                 Then Exit Sub
            objFileInfo = New System.IO.FileInfo(strPhysicalPath)
            Response.Clear()
            Response.ClearHeaders()
            Response.ClearContent()
            'Add Headers to enable dialog display
            Response.AddHeader("Content-Disposition", "attachment; filename=" & _
                objFileInfo.Name)
            Response.AddHeader("Content-Length", objFileInfo.Length.ToString())

            Response.ContentType = "application/octet-stream"
            Response.WriteFile(objFileInfo.FullName)
        Catch ex As Exception
            lblMessage.Text = ex.Message.ToString
        End Try
    End Sub
End Class
